#!/usr/bin/python
##### Rayleighjeva, Ricejeva in log-normalna porazdelitev - S53MV 25.04.2018 #####

import math,numpy	#uporabljene funkcije
import scipy.special as ss	#potrebuje instalacijo "python-scipy"

k=0.001		#korak risanja v radianih
emax=0.2	#izpad zveze

ep=math.sqrt(2)	#ep Rayleigh

s=0.5		#sigma Rice
e0=1		#e0

mdb=4		#mdb log-normalna porazdelitev
sdb=6		#sdb

x=[]		#polja za risanje grafa
y=[]
z=[]
w=[]

def Rayleigh(e,ep):	#Rayleighjeva porazdelitev
	return 2.0*e/float(ep*ep)*math.exp(-e*e/float(ep*ep))

def Rice(e,e0,s):	#Riceova porazdelitev
	return e/float(s*s)*math.exp(-(e*e+e0*e0)/float(2*s*s))*ss.i0(e*e0/float(s*s))

def Lognormalna(e,mdb,sdb):	#log-normalna porazdelitev
	em=20*math.log10(e)-mdb
	return 20.0/(sdb*math.sqrt(2*math.pi))*math.exp(-em*em/float(2*sdb*sdb))/math.log(10)/e

e=k/2.0		#kot theta v radianih
while e<emax:
	x=x+[e]			#dodaj tocko v risbo
	f=Rayleigh(e,ep)
	y=y+[f]
	f=Rice(e,e0,s)
	z=z+[f]
	f=Lognormalna(e,mdb,sdb)
	w=w+[f]
	e=e+k			#povecaj t za korak

print numpy.sum(y)*k,numpy.sum(z)*k,numpy.sum(w)*k

import matplotlib.pyplot as plt		#risanje grafa funkcije
fig=plt.figure(figsize=(6,6))
plt.plot(x,y,'r-')
plt.plot(x,z,'g-')
plt.plot(x,w,'b-')
plt.title('Rayleighjeva, Riceova in log-normalna porazdelitev\n')
plt.xlabel('Relativna jakost polja $E/E_{REF}$')
plt.ylabel('Gostota verjetnosti $p(E)$')
plt.grid(True)
fig.savefig('izpad.svg', transparent=True)
plt.show()

#konec programa

